package example;

import java.io.*; 

import au.com.hardlight.lm.*;
/**
 * Basic Useage Example. 
 * @author Jason Eacott
 *
 */
public class Example
{
//	declare a Manager object in an object that will persist for the lifetime of the application.
//	eg in a servlet or singleton object.  
	private Manager mn=null;
	
	/**
	 * @param args first arg is any string representing this licence key. 
	 * second arg is any string that can be used as a namespace or category definition. 
	 */
	public static void main(String[] args)
		{
			try
				{
					String defaultKey="mylicence.key";
					String defaultNameSpace="";
					//String defaultNameSpace="hardlight.com.au.test";
					Example test=new Example();
					String 	key=(args.length==0)?defaultKey:new String(args[0]);
					String nameSpace=(args.length==2)?new String(args[1]):defaultNameSpace;
					//create a new licence
					test.init(key,nameSpace);
					//check its state
					test.testLicence();
					System.out.println("hit return to re verify our licence:");
					System.out.println("*note, if this licence was invalid it could be validated here.");
					readLine();
					test.testVerify();
					System.out.println("hit return to end this application and unlock this key:");
					readLine();
					test.mn.close();
					System.out.println("shutdown");
				}
			catch (Exception e)
				{
					e.printStackTrace();
				}
		}
	
	public void init(String key,String nameSpace) throws Exception
	{
		/*
		 *create a new Manager
		 *should be created just once.
		 */		
		mn=new Manager(key,nameSpace); 	
		System.out.println(mn.getLicenceKey()); //will print "mylicence.key"
	}
	
	public void testLicence()
		{
			try
				{
					//test if our licence status is ok
					if (mn.getStrLicenced().equals(mn.getLicenceStatus()))
						{ 
							System.out.println("The Key "+mn.getLicenceKey()+" is valid");
						}
					else
						{
							System.out.println("The Key "+mn.getLicenceKey()+" is INVALID. There is already an application running with this key");
						}
					
				}
			catch (Exception e)
				{
					e.printStackTrace();
				}	
			
		}
	
	public void testVerify()
		{
			try 
				{	
					mn.verify();		
					testLicence();
				}
			catch (Exception e)
				{
					e.printStackTrace();
				}	
		}		
	
	public static String readLine()
		{
			StringBuffer response = new StringBuffer();
			try
				{
					BufferedInputStream bin = new BufferedInputStream(System.in);
					int in = 0;
					char inChar;
					do
						{
							in = bin.read();
							inChar = (char) in;
							if (in != -1)
								{
									response.append(inChar);
								}
						} while ((in != -1) & (inChar != '\n'));
					return response.toString();
				}
			catch (IOException e)
				{
					System.out.println("Exception: " + e.getMessage());
					return null;
				}
		}
	
}


